    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------------
    028     * XIntervalDataItem.java
    029     * ----------------------
    030     * (C) Copyright 2006, 2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 20-Oct-2006 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.data.xy;
    042
    043    import org.jfree.data.ComparableObjectItem;
    044
    045    /**
    046     * An item representing data in the form (x, x-low, x-high, y).
    047     *
    048     * @since 1.0.3
    049     */
    050    public class XIntervalDataItem extends ComparableObjectItem {
    051
    052        /**
    053         * Creates a new instance of <code>XIntervalDataItem</code>.
    054         *
    055         * @param x  the x-value.
    056         * @param xLow  the lower bound of the x-interval.
    057         * @param xHigh  the upper bound of the x-interval.
    058         * @param y  the y-value.
    059         */
    060        public XIntervalDataItem(double x, double xLow, double xHigh, double y) {
    061            super(new Double(x), new YWithXInterval(y, xLow, xHigh));
    062        }
    063
    064        /**
    065         * Returns the x-value.
    066         *
    067         * @return The x-value (never <code>null</code>).
    068         */
    069        public Number getX() {
    070            return (Number) getComparable();
    071        }
    072
    073        /**
    074         * Returns the y-value.
    075         *
    076         * @return The y-value.
    077         */
    078        public double getYValue() {
    079            YWithXInterval interval = (YWithXInterval) getObject();
    080            if (interval != null) {
    081                return interval.getY();
    082            }
    083            else {
    084                return Double.NaN;
    085            }
    086        }
    087
    088        /**
    089         * Returns the lower bound of the x-interval.
    090         *
    091         * @return The lower bound of the x-interval.
    092         */
    093        public double getXLowValue() {
    094            YWithXInterval interval = (YWithXInterval) getObject();
    095            if (interval != null) {
    096                return interval.getXLow();
    097            }
    098            else {
    099                return Double.NaN;
    100            }
    101        }
    102
    103        /**
    104         * Returns the upper bound of the x-interval.
    105         *
    106         * @return The upper bound of the x-interval.
    107         */
    108        public double getXHighValue() {
    109            YWithXInterval interval = (YWithXInterval) getObject();
    110            if (interval != null) {
    111                return interval.getXHigh();
    112            }
    113            else {
    114                return Double.NaN;
    115            }
    116        }
    117
    118    }